From b01860ccfc70c924587385d675800fb1c07338cf Mon Sep 17 00:00:00 2001
From: Akash Mehrotra <mehrotra.akash@gmail.com>
Date: Sun, 5 Jun 2011 01:03:11 +0530
Subject: [PATCH] http interface can now change and view audio delay

---
 share/lua/http/dialogs/main        |   11 +++++++++++
 share/lua/http/js/functions.js     |   16 ++++++++++++++++
 share/lua/http/requests/README.txt |    3 +++
 share/lua/http/requests/status.xml |    5 +++++
 4 files changed, 35 insertions(+), 0 deletions(-)

diff --git a/share/lua/http/dialogs/main b/share/lua/http/dialogs/main
index 8de8374..5a6e837 100644
--- a/share/lua/http/dialogs/main
+++ b/share/lua/http/dialogs/main
@@ -98,6 +98,17 @@ sout and playlist .
       <img src="images/speaker_mute.png" alt="Mute Volume" />
       <span class="btn_text">Mute Volume</span>
     </button>
+    <br />
+    Audio Delay:
+    <button id="btn_delay_down" onclick="audiodelay_down();" onmouseover="button_over(this);" onmouseout="button_out(this);" title="Decrease Audio Delay by 50ms" >
+      <img src="images/minus.png" alt="Decrease Volume" />
+      <span class="btn_text">Decrease Audio Delay</span>
+    </button>
+    <button id="btn_delay_up" onclick="audiodelay_up();" onmouseover="button_over(this);" onmouseout="button_out(this);" title="Increase Audio Delay by 50ms" >
+      <img src="images/plus.png" alt="Increase Volume" />
+      <span class="btn_text">Increase Audio Delay</span>
+    </button>
+    <span id="a_del">(?)</span> ms
 
   </div>
   <div id="status">
diff --git a/share/lua/http/js/functions.js b/share/lua/http/js/functions.js
index d751716..42ca9b2 100644
--- a/share/lua/http/js/functions.js
+++ b/share/lua/http/js/functions.js
@@ -416,6 +416,20 @@ function reset_search()
         update_playlist_search('')
     }
 }
+function audiodelay_down()
+{
+    var curdel = parseFloat(req.responseXML.documentElement.getElementsByTagName( 'audiodelay' )[0].firstChild.data);
+    var curdelnew = curdel - 0.05;
+    curdelnew=curdelnew.toFixed(2);
+    loadXMLDoc( 'requests/status.xml?command=audiodelay&val='+encodeURIComponent(curdelnew), parse_status );
+}
+function audiodelay_up()
+{
+    var curdel = parseFloat(req.responseXML.documentElement.getElementsByTagName( 'audiodelay' )[0].firstChild.data);
+    var curdelnew = curdel + 0.05;
+    curdelnew=curdelnew.toFixed(2);
+    loadXMLDoc( 'requests/status.xml?command=audiodelay&val='+encodeURIComponent(curdelnew), parse_status );
+}
 
 /**********************************************************************
  * Parse xml replies to XMLHttpRequests
@@ -467,6 +481,8 @@ function parse_status()
             old_time = new_time;
             set_text( 'time', format_time( new_time ) );
             set_text( 'length', format_time( length ) );
+            var audio_delay = (parseFloat(req.responseXML.documentElement.getElementsByTagName( 'audiodelay' )[0].firstChild.data).toFixed(2))*1000;
+            set_text( 'a_del', audio_delay ); 
             if( status.getElementsByTagName( 'volume' ).length != 0 )
                 set_text( 'volume', Math.floor(status.getElementsByTagName( 'volume' )[0].firstChild.data/5.12)+'%' );
             var statetag = status.getElementsByTagName( 'state' );
diff --git a/share/lua/http/requests/README.txt b/share/lua/http/requests/README.txt
index f3a7667..a0eabd8 100644
--- a/share/lua/http/requests/README.txt
+++ b/share/lua/http/requests/README.txt
@@ -50,6 +50,9 @@ status.xml:
 > empty playlist:
   ?command=pl_empty
 
+> set audio delay
+  ?command=audiodelay&val=<delayinseconds>
+
 > sort playlist using sort mode <val> and order <id>:
   ?command=pl_sort&id=<id>&val=<val>
   If id=0 then items will be sorted in normal order, if id=1 they will be
diff --git a/share/lua/http/requests/status.xml b/share/lua/http/requests/status.xml
index bbef12d..dbad4e5 100644
--- a/share/lua/http/requests/status.xml
+++ b/share/lua/http/requests/status.xml
@@ -111,6 +111,10 @@ elseif command == "seek" then
   common.seek(val)
 elseif command == "key" then
   common.hotkey("key-"..val)
+elseif command == "audiodelay" then
+  if vlc.object.input() and val then
+   vlc.var.set(vlc.object.input(),"audio-delay",val)
+  end
 end
 
 local input = nil
@@ -125,6 +129,7 @@ local vout = input and vlc.object.find(input,'vout','child')
 ?>
 <root>
   <volume><?vlc print(vlc.volume.get()) ?></volume>
+  <audiodelay><?vlc if input then print(vlc.var.get(input,"audio-delay")) else print (0) end ?></audiodelay>
   <length><?vlc if input then print(math.floor(vlc.var.get(input,"length"))) else print(0) end?></length>
   <time><?vlc if input then print(math.floor(vlc.var.get(input,"time"))) else print(0) end?></time>
   <state><?vlc print(vlc.playlist.status()) ?></state>
-- 
1.7.4.1

